import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCoachCur, ThinkCoachCurParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询教练课程表
 */
export async function pageThinkCoachCur(params: ThinkCoachCurParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCoachCur>>>(
    THINK_API_URL + '/think/think-coach-cur/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询教练课程表列表
 */
export async function listThinkCoachCur(params?: ThinkCoachCurParam) {
  const res = await request.get<ApiResult<ThinkCoachCur[]>>(
    THINK_API_URL + '/think/think-coach-cur',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加教练课程表
 */
export async function addThinkCoachCur(data: ThinkCoachCur) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cur',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改教练课程表
 */
export async function updateThinkCoachCur(data: ThinkCoachCur) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cur',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除教练课程表
 */
export async function removeThinkCoachCur(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cur/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除教练课程表
 */
export async function removeBatchThinkCoachCur(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach-cur/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询教练课程表
 */
export async function getThinkCoachCur(id: number) {
  const res = await request.get<ApiResult<ThinkCoachCur>>(
    THINK_API_URL + '/think/think-coach-cur/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
